from setuphelpers import *
import json
import re
import requests



def update_package():
    # Déclaration des variables locales
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    # Récupération du contenu de l'index principal
    main_index = wgets("https://cdn.kde.org/ci-builds/utilities/kate/", proxies=proxies)

    # Expression régulière pour trouver les dossiers de release
    re_release_folders = re.compile(r'release-(\d+\.\d+)/')

    # Trouver les versions de release disponibles
    release_folders = sorted(re_release_folders.findall(main_index), key=lambda p: Version(p), reverse=True)

    # Si aucune version n'est trouvée
    if not release_folders:
        print("No releases version found.")
        return

    # Prendre le dernier dossier de release
    latest_release = release_folders[0]
    latest_release_url = f"https://cdn.kde.org/ci-builds/utilities/kate/release-{latest_release}/macos-x86_64/"
    print(f"URL last release : {latest_release_url}")

    # Récupération de la dernière version à partir des sources officielles
    re_versions = re.compile(r'kate-release_(\d+\.\d+)-(\d+)-macos-clang-x86_64\.dmg')
    index = wgets(latest_release_url, proxies=proxies)
    print(f"Last index release :\n{index}")

    # Extraction des versions trouvées dans l'index
    versions_found = re_versions.findall(index)
    print(f"Versions found : {versions_found}")

    for version_kate, build_number in sorted(versions_found, key=lambda p: Version(p[0]), reverse=True):
        latest_bin = f"kate-release_{version_kate}-{build_number}-macos-clang-x86_64.dmg"
        download_url = f"{latest_release_url}{latest_bin}"

        if requests.head(download_url, proxies=proxies).status_code != 404:
            version = version_kate
            print(f"Download {version} with {download_url}")
            break
    else:
        print("no version found.")

    if not isfile(latest_bin):
        package_updated = True
        wget(download_url, latest_bin, proxies=proxies)

    # nettoyer les fichiers temporaires
    for f in glob.glob("*.dmg"):
        if f != latest_bin:
            remove_file(f)


    control.set_software_version(version)
    control.save_control_to_wapt()